{{ $labelData := dict "Values" .Values "Release" .Release "Chart" .Chart "Component" "web" }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "concierge.name" . }}
  labels:
    {{- include "concierge.labels" $labelData | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "concierge.selectorLabels" $labelData | nindent 6 }}
  strategy:
    rollingUpdate:
      maxSurge: {{ add .Values.replicaCount 1 }}
      maxUnavailable: 0
    type: RollingUpdate
  template:
    metadata:
      name: {{ include "concierge.name" . }}
      labels:
        {{- include "concierge.selectorLabels" $labelData | nindent 8 }}
    spec:
      containers:
        - name: {{ include "concierge.name" . }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: 8000
              protocol: TCP
          volumeMounts:
            - mountPath: /app/media
              name: media
          envFrom:
            - configMapRef:
                name: {{ include "concierge.name" . }}
            - secretRef:
                name: {{ include "concierge.secretsName" . }}
          env:
            - name: SAML_SP_X509CERT
              valueFrom:
                secretKeyRef:
                  key: tls.crt
                  name: {{ include "concierge.samlSecretName" . }}
            - name: SAML_SP_PRIVATEKEY
              valueFrom:
                secretKeyRef:
                  key: tls.key
                  name: {{ include "concierge.samlSecretName" . }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      volumes:
        - name: media
          persistentVolumeClaim:
            claimName: {{ include "concierge.mediaClaimName" . }}
